#import bevy_pbr::mesh_vertex_output MeshVertexOutput

struct FloorMaterial {
    color: vec4<f32>,
    tile: f32
};

@group(1) @binding(0)
var<uniform> material: FloorMaterial;
@group(1) @binding(1)
var base_color_texture: texture_2d<f32>;
@group(1) @binding(2)
var base_color_sampler: sampler;

@fragment
fn fragment(
    mesh: MeshVertexOutput
) -> @location(0) vec4<f32> {
    var tiled_uv: vec2<f32>;
    tiled_uv = mesh.uv;
    if(material.tile > 0.0) {
        var tiled_uv_x: f32;
        var tiled_uv_y: f32;
        tiled_uv_x = fract(mesh.uv.x * 50.0);
        tiled_uv_y = fract(mesh.uv.y * 50.0);
        tiled_uv = vec2(tiled_uv_x,tiled_uv_y);
    }
    return textureSample(base_color_texture, base_color_sampler, tiled_uv);
}